/*

 */

#include "ext.h"


typedef struct
{
  t_object o;

  int   pre;
  int   fois;
  int   iter;

  float aa;    
  float bb;
  float aaw;    
  float bbw;
  float aax;    
  float bbx;
  float ww;    
  float xx;
  float cc;    
  float vv;
  float gg;    
  float nn;

  void *outlet_0;
  void *outlet_1;
} calcultest_t;


void *calcultest_class;


static void
calcultest_sendparam (t_object *o, long a, long b, long c)
{
  calcultest_t *self = (calcultest_t *) o;

  self->pre  = a;
  self->fois = b;
  self->iter = c;

  outlet_int(self->outlet_1, a);
  outlet_int(self->outlet_1, b);
  outlet_int(self->outlet_1, c);
}



static void
calcultest_calcultest (t_object *o)
{
# define F_DEFAULT 1.1;
  calcultest_t *self = (calcultest_t *) o;
  int i, j;
  float f1, f2, f3, f4;

  f1 = F_DEFAULT;
  f2 = F_DEFAULT;
  f3 = F_DEFAULT;
  f4 = F_DEFAULT;

  for (i = 0; i < self->fois * 10; i++)
  {
    for (j = self->pre; j < self->pre + self->iter; j++)
    {
     	f1=f1+((j+self->aa)/(j-self->bb))+((j+self->bbw)/(j-self->aaw))-((j-self->aax)/(j+self->bbx));
	f2=f2+((j*self->ww+self->aa)/(j*self->xx-self->bb))+((j*self->cc+self->bbw)/(j*self->vv-self->aaw))-((j*self->gg-self->aax)/(j*self->nn+self->bbx));
	f3=f3+((j/self->ww+self->aa)/(j/self->xx-self->bb))+((j/self->cc+self->bbw)/(j/self->vv-self->aaw))-((j/self->gg-self->aax)/(j/self->nn+self->bbx));
	f4=f4+((j+self->ww)/(j+self->xx))+((j+self->cc)/(j+self->vv))-((j+self->gg)/(j+self->nn));
    }
  }

  outlet_int(self->outlet_0, 3);
  outlet_float(self->outlet_1, f1);
  outlet_float(self->outlet_1, f2);
  outlet_float(self->outlet_1, f3);
  outlet_float(self->outlet_1, f4);
}



/***************************************************************
*
* class
*
*/

static void *calcultest_new (Symbol *s, short ac, Atom *at)
{ 
  calcultest_t *self = (calcultest_t *) newobject(calcultest_class);

  post("this is calcultest!\n");

  self->outlet_1 = outlet_new((t_object *) self, 0);
  self->outlet_0 = outlet_new((t_object *) self, 0);

  /* init test values */
  self->aa=144.34;
  self->bb=177.77;
  self->aaw=166.34;
  self->bbw=133.77;
  self->aax=191.34;
  self->bbx=122.77;
  self->ww=0.934;
  self->xx=0.977;
  self->cc=0.914;
  self->vv=1.047;
  self->gg=1.034;
  self->nn=1.2277;

  return self;
}


static void calcultest_free (calcultest_t *self)
{

}


void main (void)
{
    setup((t_messlist **) &calcultest_class, (method) calcultest_new, (method) calcultest_free, (short) sizeof(calcultest_t), 0, A_GIMME, 0);

    /* inlet method */
    addmess((method) calcultest_sendparam, "sendparam", A_LONG, A_LONG, A_LONG, 0);
    addmess((method) calcultest_calcultest,  "calcultest",  0);
}

/** EMACS **
* Local variables:
* mode: c
* c-basic-offset:2
* End:
*/
